	/// Global event handlers
	var callbacks = {};
	var list_accounts = "";
	var list_users = "";
	var list_units = "";
	
	
	function get_user_by_name(name) {		
		// load list cmd
		for (var i = 0; i < list_users.length; i++) {
			var user = list_users[i];
			var user_name = user.getName();	
			if (name == user_name) 
				return user;
		}
		return "NULL";
	}
	function get_user_by_id(id) {		
		// load list cmd
		for (var i = 0; i < list_users.length; i++) {
			var user = list_users[i];
			var user_name = user.getId();	
			if (id == user_name) 
				return user;
		}
		return "NULL";
	}
	function get_unit_by_id(id) {
		// load list cmd
		for (var i = 0; i < list_units.length; i++) {
			var unit = list_units[i];
			var unit_id = unit.getId();
			
			if (id == unit_id) 
				return unit;
		}
		return "NULL";
	}

	function show_hide_block(id_block) {
		var plugin_div = jQuery("#" + id_block);
		if (plugin_div.css("display") == "none") {
			plugin_div.show();
			return true;
		} else {
			plugin_div.hide();
			return false;
		}
	}

	function load_accounts() {
		
		jQuery("#login").append("<b>" + curr_user_session.getName() + "</b>");
		
		load_default_param_sendmail();		
			
		$("#process").html("<img src='img/load.gif'/><div id='percent_process'></div>");
		
		// flags to specify what kind of data should be returned
		var flags = wialon.item.Item.dataFlag.base | wialon.item.Item.dataFlag.billingProps | wialon.item.Item.dataFlag.customProps;
		session.loadLibrary("resourceAccounts"); // load Accounts Library
		session.updateDataFlags( // load items to current session
			[{type: "type", data: "avl_resource", flags: flags, mode: 0}], // Items specification
		function (code) { // updateDataFlags callback
			if (code) { msg(wialon.core.Errors.getErrorText(code)); return; } // exit if error code
			list_accounts = session.getItems("avl_resource"); // get loaded 'avl_resource' items
			if (!list_accounts || !list_accounts.length){ alert("No resources found"); return; } // check if resources found
			// get list uers
			var dataFlags = wialon.item.Item.dataFlag.base | wialon.item.Item.dataFlag.customProps  | wialon.item.User.dataFlag.connSettings | wialon.item.User.dataFlag.flags |wialon.item.Item.accessFlag.editOther ;
			var spec = [{type: "type", data: "user", flags: dataFlags, mode: 0}];
			wialon.core.Session.getInstance().updateDataFlags(spec, function(code) {
				if (code) { msg(wialon.core.Errors.getErrorText(code)); return; }
				list_users = session.getItems("user");		
			
				// get list units
				// init wialon event system
				var spec = [{type: "type", data: "avl_unit", flags: dataFlags, mode: 0}];
				wialon.core.Session.getInstance().updateDataFlags(spec, function(code) {
					if(code) {
						alert("updateDataFlags error: ["+ code +"] " + wialon.core.Errors.getErrorText(code));
						return;
					}
					
					// load units
					list_units = wialon.core.Session.getInstance().getItems("avl_unit");
					
					show_list_accounts();	
					
				}, this);								
			}, this);				
		});
	}
	
	var active_index = 0;
	var unit_acl_all = 0;
	var mail_array = new Array();
	
	// print list accounts
	function show_list_accounts() {
	
		if (active_index % 10 == 0)
			$("#percent_process").html("<b>" + (active_index * 100/list_accounts.length).toFixed(0)  + " %" + "</b>");
		
		if (active_index >= list_accounts.length) {
			$("#process").html("");
			$("#accounts").append("<tr><td></td><td><b>Итого:</b></td><td></td><td></td><td></td>" +
						"<td></td><td>" + unit_acl_all + "</td><td></td><td></td>" + 
						"<td></td></tr>");
			return;
		}
		var account = list_accounts[active_index];	
		
		if (account.getId() != account.getAccountId()) {
			active_index++;
			show_list_accounts();
			return;
		}			
		
		var creator = "-";
		if (get_user_by_id(account.getCreatorId()) != "NULL")
			creator = get_user_by_id(account.getCreatorId()).getName();
		
		account.getAccountData( function(code, data){ // Get account information as JSON Object
			if(code){ alert(wialon.core.Errors.getErrorText(code)); return; } // exit if error code
			
			var id = account.getId();
			var email = account.getCustomProperty("invoice_mail");
			
			var prognoz = "";
			var cost_units = "";
			if (data.settings)
				cost_units = data.settings.combined.services.avl_unit.cost;
				
			if (cost_units != "") {
				cost_units = cost_units.split(";")[0];				
				cost_units = parseFloat(cost_units.split(":")[1]);				
				if (cost_units > 0 && data.settings.combined.services.avl_unit.usage > 0 && data.enabled) {
					prognoz = (data.settings.balance/(cost_units * data.settings.combined.services.avl_unit.usage)).toFixed();
					
					if (prognoz < 7) {
						if (email != "") {
							mail_array[mail_array.length] = "&account=" + account.getName() + "&account_days=" + prognoz + "&account_balance=" + data.balance + "&to=" + email;
							$("#res_test_mail").append("<font color='green'><b>" + account.getName() + "</b>(" + prognoz + " дн, " +  email + "),</font>  ");
						} else {
							$("#res_test_mail").append("<font color='red'><b>" + account.getName() + "</b>(" + prognoz + " дн),</font>  ");
						}
					}
					
					if (prognoz < 2)
						prognoz = "<font color='red'><b>" + prognoz + "</b></font>";
					else if (prognoz < 5)
						prognoz = "<font color='darkorange'><b>" + prognoz + "</b></font>";
						
				}
			}
			
			var email_html = "";
			if (email != "")
				email_html = "<input type='text' value='" + email + "' readonly id='input_email_" + id + "'> &nbsp;&nbsp; <input type='button' value='Изменить' onClick=\"edit_input_email(" + id + ");\">";
			else 
				email_html = "<input type='text' value='" + email + "' id='input_email_" + id + "'>";
				
			email_html = email_html + "&nbsp;&nbsp; <input type='button' value='Сохранить' onClick=\"save_email_account(" + id + ");\">";
			
			var unit_usage = "";
			var balance = ""
			if (data.settings) {
				unit_usage = data.settings.combined.services.avl_unit.usage;
				balance = data.settings.balance;
			}
			
			
			var unit_acl = "";
			var user= get_user_by_id(account.getCreatorId());
			if (user != "NULL") {
				user.getItemsAccess(true, "avl_unit", function(code,result) {
					if (code) { msg(wialon.core.Errors.getErrorText(code)); return; }
					var count = 0;
					var string_units = "";
					for(var unit_id in result) {
						var unit = get_unit_by_id(unit_id);
						if (unit != "NULL")
							string_units = string_units + unit.getName() + ", ";
						count++;
					}	
					unit_acl = count;
					if (curr_user_session.getName() != account.getName())
						unit_acl_all = unit_acl_all + unit_acl;
					// create message with account data
					$("#accounts").append("<tr id='tr_" + active_index + "'><td>" + (active_index + 1) + "</td><td id='td_name_" + active_index + "'>" + account.getName() + "</td><td id='td_creator_" + active_index + "'>" + creator + "</td><td id='td_tp_" + active_index + "'>" + data.plan + "</td><td id='td_balance_" + active_index + "'>" + balance + "</td><td id='td_day_" + active_index + "'>" + data.daysCounter + "</td>" +
							"<td id='td_unit1_" + active_index + "'>" + unit_usage + "</td><td id='td_unit2_" + active_index + "'>" + unit_acl + " </td><td> <img src='img/show.png' style='cursor: pointer;' onClick=\"show_hide_block('div_list_unit_" + account.getId() + "');\" /> <div id='div_list_unit_" + account.getId() + "' style='display: none;'>" + string_units + "</div></td><td>" + prognoz + "</td><td>" + (data.enabled ? "enabled" : "<font color='red'><b>blocked</b></font>") + "</td>" + 
							"<td>" + email_html + "</td></tr>");
				
					active_index++;
					show_list_accounts();
					
				});
			} else {
				// create message with account data
				$("#accounts").append("<tr><td>" + (active_index + 1) + "</td><td id='td_name_" + active_index + "'>" + account.getName() + "</td><td id='td_creator_" + active_index + "'>" + creator + "</td><td id='td_tp_" + active_index + "'>" + data.plan + "</td><td id='td_balance_" + active_index + "'>" + balance + "</td><td id='td_day_" + active_index + "'>" + data.daysCounter + "</td>" +
						"<td id='td_unit1_" + active_index + "'>" + unit_usage + "</td><td id='td_unit2_" + active_index + "'>" + unit_acl + "</td><td>" + prognoz + "</td><td>" + (data.enabled ? "enabled" : "<font color='red'><b>blocked</b></font>") + "</td>" + 
						"<td>" + email_html + "</td></tr>");
						
				active_index++;
				show_list_accounts();
			}		
				
		});				
	}
	
	// save email account
	function save_email_account(id) {
		var active_account = wialon.core.Session.getInstance().getItem(id);
		var mail = jQuery("#input_email_" + id).val();
		active_account.updateCustomProperty("invoice_mail",mail,qx.lang.Function.bind(function(code) {
			$('#input_email_' + id).attr('readonly', true);
		}, this));
	}
	// edit email account
	function edit_input_email(id) {
		$('#input_email_' + id).attr('readonly', false);
	}
	
	// show/hide html block
	function show_hide_block(id_block) {
		var plugin_div = jQuery("#" + id_block);
		if (plugin_div.css("display") == "none") {
			plugin_div.show();
			return true;
		} else {
			plugin_div.hide();
			return false;
		}
	}

	function sendmail(from,to,service,params)
	{
		var dat ="";
		if (to != "")
			dat = "from=" + from + "&to=" + to + "&service=" + service;
		else 
			dat = "from=" + from + "&service=" + service + params;
			
		$.ajax({
			url: 'ajax/sendmail.php',
			data: dat,
			success: function(data) {
				if (data != "") {
					$("#res_send_mail").append(data);
				}
			}
		});	
	   
	}
	
	// send mail
	function send_mail()
	{
		var name_service = jQuery("#name_service").val();
		var mail_from = jQuery("#mail_from").val();
		
		for(var i = 0; i < mail_array.length; i++)
			sendmail(mail_from,"",name_service,mail_array[i])
	}
	
	// test mail
	function send_test_mail()
	{
		var mail = jQuery("#mail_test").val();
		if (mail == "") {
			$("#res_send_mail").html("<font color='red'>Введите тестовый email</font>");
			return;
		}
		var name_service = jQuery("#name_service").val();
		var mail_from = jQuery("#mail_from").val();
		
		curr_user_session.updateCustomProperty("skmail_name_service",name_service,qx.lang.Function.bind(function(code) {		
			curr_user_session.updateCustomProperty("skmail_mail_test",mail,qx.lang.Function.bind(function(code) {
				curr_user_session.updateCustomProperty("skmail_mail_from",mail_from,qx.lang.Function.bind(function(code) {
				}, this));
			}, this));
		}, this));
		
		sendmail(mail_from,mail,name_service);
	}
	
	function load_default_param_sendmail()
	{
		jQuery("#name_service").val(curr_user_session.getCustomProperty("skmail_name_service"));
		
		jQuery("#name_service").val(curr_user_session.getCustomProperty("skmail_name_service"));
		jQuery("#mail_test").val(curr_user_session.getCustomProperty("skmail_mail_test"));
		jQuery("#mail_from").val(curr_user_session.getCustomProperty("skmail_mail_from"));
	}
	
	function filtr() {
		
		var name = $("#filtr_name").val();
		var tp = $("#filtr_tp").val();
		var creator = $("#filtr_creator").val();
		var balance = $("#filtr_balance").val();
		var day = $("#filtr_day").val();
		var unit1 = $("#filtr_unit1").val();
		var unit2 = $("#filtr_unit2").val();
		
		
		if (active_index < list_accounts.length) {
			alert("Дождитесь пожалуйста загрузки информациии по всем учётным записям.");
			return;
		}
		
		for (var i = 0; i < list_accounts.length; i++) {	
			
			var str = $("#td_name_" + i).html();
			if (str == null)
				continue;
			
			$("#tr_" + i).show();
			
			if (name != "" && name != "*") {
				var str = $("#td_name_" + i).html();
				console.log (str + " / ind=" + str.indexOf(name));
				if(str.indexOf(name) < 0) 
					$("#tr_" + i).hide();
			}
			
			if (tp != "" && tp != "*") {
				if($("#td_tp_" + i).html() != tp) 
					$("#tr_" + i).hide();
			}
			if (creator != "" && creator != "*") {
				if($("#td_creator_" + i).html() != creator) 
					$("#tr_" + i).hide();
			}
			if (balance != "" && balance != "*") {
				if( parseFloat($("#td_balance_" + i).html()) > parseFloat(balance)) 
					$("#tr_" + i).hide();
			}
			if (day != "" && day != "*") {
				if( parseFloat($("#td_day_" + i).html()) > parseFloat(day)) 
					$("#tr_" + i).hide();
			}
			if (unit1 != "" && unit1 != "*") {
				if( parseFloat($("#td_unit1_" + i).html()) < parseFloat(unit1)) 
					$("#tr_" + i).hide();
			}
			if (unit2 != "" && unit2 != "*") {
				if( parseFloat($("#td_unit2_" + i).html()) < parseFloat(unit2)) 
					$("#tr_" + i).hide();
			}
		}
	}