﻿<?php
	
	include 'wialon_hosting.php';
	include 'logs.php';
	
	function sk_trace($str) 
	{
		// default params
		$file_log = $_SERVER["DOCUMENT_ROOT"]."/logs/sk_trace.log";
				
		$date = date("Y/m/d H:i:s:");
		
		$file = fopen($file_log, "a+");
		if (!$file) {
			return;
		}
		
		fwrite($file, "$date $str \r\n"); 
		fclose($file); 
	}
	
	function wialon_request($svc,$sid,$params) 
	{
		$fp = fsockopen("hst-api.wialon.com", 80, $errno, $errstr, 60);
		if (!$fp) {
		    sk_trace("error wialon_request: $errstr ($errno)");
			return;
		} 
		if ($sid != "")
			$data = "svc=" . $svc . "&sid=" . $sid . "&params=" . $params . "\r\n";
		else 
			$data = "svc=" . $svc . "&params=" . $params . "\r\n";
			
		$out = "POST /wialon/ajax.html HTTP/1.0\r\n";
		$out .= "Host: hst-api.wialon.com\r\n";
		$out .= "Content-type: application/x-www-form-urlencoded\r\n";
		$out .= "Content-length: ".strlen($data)."\r\n";
		$out .= "Connection: Close\r\n\r\n";
		$out .= $data."\r\n\r\n";
		
		$html = '';
		
		fwrite($fp, $out);
		while (!feof($fp)) {
			$html .= fgets($fp, 128);
		}
		fclose($fp);
		
		$pos = strpos($html, "\r\n\r\n");
		if ($pos > 0) {
			$html = substr($html, $pos+4);
		}
		
		
		sk_trace ("answer (svc=$svc,params=$params): $html");
		
		$json = json_decode($html);
		if ($json->{'error'} != "") {
			sk_trace ("Error POST request $html /debug: (svc=$svc,params=$params)");
		}
		return $json;		
	}
	
	function cross_platform_request($str) 
	{
		$fp = fsockopen("license.sk-system.ru", 80, $errno, $errstr, 60);
		if (!$fp) 
			return;
			
		sk_trace ("Data=$str");
		$data = "license=". $_SERVER['HTTP_HOST'] ." " . $str . "\r\n";
		$out = "POST /license.php HTTP/1.0\r\n";
		$out .= "Host: license.sk-system.ru\r\n";
		$out .= "Content-type: application/x-www-form-urlencoded\r\n";
		$out .= "Content-length: ".strlen($data)."\r\n";
		$out .= "Connection: Close\r\n\r\n";
		$out .= $data."\r\n\r\n";
		
		fwrite($fp, $out);
		fclose($fp);
	}

	function parseInt($string) {
		if(preg_match('/(\d+)/', $string, $array)) {
			return $array[1];
		} else {
			return 0;
		}
	}
	
	function json_fix_cyr($json_str) {
		$cyr_chars = array (
			'\u0430' => 'а', '\u0410' => 'А',
			'\u0431' => 'б', '\u0411' => 'Б',
			'\u0432' => 'в', '\u0412' => 'В',
			'\u0433' => 'г', '\u0413' => 'Г',
			'\u0434' => 'д', '\u0414' => 'Д',
			'\u0435' => 'е', '\u0415' => 'Е',
			'\u0451' => 'ё', '\u0401' => 'Ё',
			'\u0436' => 'ж', '\u0416' => 'Ж',
			'\u0437' => 'з', '\u0417' => 'З',
			'\u0438' => 'и', '\u0418' => 'И',
			'\u0439' => 'й', '\u0419' => 'Й',
			'\u043a' => 'к', '\u041a' => 'К',
			'\u043b' => 'л', '\u041b' => 'Л',
			'\u043c' => 'м', '\u041c' => 'М',
			'\u043d' => 'н', '\u041d' => 'Н',
			'\u043e' => 'о', '\u041e' => 'О',
			'\u043f' => 'п', '\u041f' => 'П',
			'\u0440' => 'р', '\u0420' => 'Р',
			'\u0441' => 'с', '\u0421' => 'С',
			'\u0442' => 'т', '\u0422' => 'Т',
			'\u0443' => 'у', '\u0423' => 'У',
			'\u0444' => 'ф', '\u0424' => 'Ф',
			'\u0445' => 'х', '\u0425' => 'Х',
			'\u0446' => 'ц', '\u0426' => 'Ц',
			'\u0447' => 'ч', '\u0427' => 'Ч',
			'\u0448' => 'ш', '\u0428' => 'Ш',
			'\u0449' => 'щ', '\u0429' => 'Щ',
			'\u044a' => 'ъ', '\u042a' => 'Ъ',
			'\u044b' => 'ы', '\u042b' => 'Ы',
			'\u044c' => 'ь', '\u042c' => 'Ь',
			'\u044d' => 'э', '\u042d' => 'Э',
			'\u044e' => 'ю', '\u042e' => 'Ю',
			'\u044f' => 'я', '\u042f' => 'Я',

			'\r' => '',
			'\n' => '<br />',
			'\t' => ''
		);
	
		foreach ($cyr_chars as $cyr_char_key => $cyr_char) {
			$json_str = str_replace($cyr_char_key, $cyr_char, $json_str);
		}
		return $json_str;
	} 
?>
